/*-
 * ~~~~~~licensing~~~~~~
 * base-support
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.base.support.osgi.tracker.filter;

import ru.entaxy.platform.base.support.osgi.tracker.BundleFilter;

public abstract class AbstractBundleFilter<T, C extends AbstractBundleFilter<T, C>> implements BundleFilter<T>  {

	protected String filterId = getDefaultFilterId();

	protected abstract String getDefaultFilterId();
	
	@Override
	public String getFilterId() {
		return filterId;
	}

	public void setFilterId(String filterId) {
		this.filterId = filterId;
	}

	public C filterId(String filterId) {
		setFilterId(filterId);
		return (C)this;
	}

}
