/*-
 * ~~~~~~licensing~~~~~~
 * adapters-core
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.util;

import org.osgi.framework.BundleContext;
import org.osgi.framework.FrameworkUtil;
import org.osgi.framework.InvalidSyntaxException;
import org.osgi.framework.ServiceReference;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.api.Adapter;

import java.util.Collection;

public class AdapterUtil {
    private static final Logger log = LoggerFactory.getLogger(AdapterUtil.class);
    public static Adapter getAdapter(String adapterName) throws InvalidSyntaxException {
        String filter = "(adapter.name=" + adapterName + ")";
        log.debug("Get adapter service filtered by: " + filter);
        BundleContext bundleContext = FrameworkUtil.getBundle(Adapter.class).getBundleContext();
        Collection<ServiceReference<Adapter>> referenceList = bundleContext.getServiceReferences(Adapter.class, filter);
        Adapter adapter = bundleContext.getService(referenceList.iterator().next());

        return adapter;
    }
}
