/*-
 * ~~~~~~licensing~~~~~~
 * artifact-management
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.artifact.installer.impl;

import ru.entaxy.platform.core.artifact.installer.ArtifactInstaller;
import ru.entaxy.platform.core.artifact.installer.builder.LocalInstaller;
import ru.entaxy.platform.core.artifact.installer.builder.impl.local.DefaultLocalInstaller;

public class DefaultLocalArtifactInstaller extends AbstractArtifactInstaller 
		implements ArtifactInstaller<LocalInstaller> {

	protected String name = ArtifactInstaller.ARTIFACT_INSTALLER_LOCAL; 
	
	@Override
	public String getName() {
		return this.name;
	}

	@Override
	public LocalInstaller createInstaller() {
		return new DefaultLocalInstaller();
	}

	public void setName(String name) {
		this.name = name;
	}

	
}
