/*-
 * ~~~~~~licensing~~~~~~
 * schema-soap
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */

package ru.entaxy.esb.platform.runtime.core.infrastructure.schema.soap.cxf;

import javax.xml.bind.JAXBElement;
import javax.xml.bind.annotation.XmlElementDecl;
import javax.xml.bind.annotation.XmlRegistry;
import javax.xml.namespace.QName;


/**
 * This object contains factory methods for each 
 * Java content interface and Java element interface 
 * generated in the ru.entaxy.esb.system.registry.schema.soap.cxf package. 
 * <p>An ObjectFactory allows you to programatically 
 * construct new instances of the Java representation 
 * for XML content. The Java representation of XML 
 * content can consist of schema derived interfaces 
 * and classes representing the binding of schema 
 * type definitions, element declarations and model 
 * groups.  Factory methods for each of these are 
 * provided in this class.
 * 
 */
@XmlRegistry
public class ObjectFactory {

    private final static QName _LoadResourceRequest_QNAME = new QName("http://www.entaxy.ru/registry-schema-service/", "loadResourceRequest");
    private final static QName _ResourceType_QNAME = new QName("http://www.entaxy.ru/registry-schema-service/", "ResourceType");
    private final static QName _FullResourceType_QNAME = new QName("http://www.entaxy.ru/registry-schema-service/", "FullResourceType");
    private final static QName _RemoveResourceRequest_QNAME = new QName("http://www.entaxy.ru/registry-schema-service/", "removeResourceRequest");
    private final static QName _GetResourceRequest_QNAME = new QName("http://www.entaxy.ru/registry-schema-service/", "getResourceRequest");
    private final static QName _LoadResourceInfoRequest_QNAME = new QName("http://www.entaxy.ru/registry-schema-service/", "loadResourceInfoRequest");
    private final static QName _EditResourceInfoRequest_QNAME = new QName("http://www.entaxy.ru/registry-schema-service/", "editResourceInfoRequest");
    private final static QName _RemoveResourceInfoRequest_QNAME = new QName("http://www.entaxy.ru/registry-schema-service/", "removeResourceInfoRequest");
    private final static QName _GetResourceInfoRequest_QNAME = new QName("http://www.entaxy.ru/registry-schema-service/", "getResourceInfoRequest");
    private final static QName _GetResourceInfoResponse_QNAME = new QName("http://www.entaxy.ru/registry-schema-service/", "getResourceInfoResponse");
    private final static QName _GetResourceInfoListResponse_QNAME = new QName("http://www.entaxy.ru/registry-schema-service/", "getResourceInfoListResponse");
    private final static QName _CreatedBy_QNAME = new QName("http://www.entaxy.ru/registry-schema-service/", "createdBy");
    private final static QName _Response_QNAME = new QName("http://www.entaxy.ru/registry-schema-service/", "response");

    /**
     * Create a new ObjectFactory that can be used to create new instances of schema derived classes for package: ru.entaxy.esb.system.registry.schema.soap.cxf
     * 
     */
    public ObjectFactory() {
    }

    /**
     * Create an instance of {@link LoadResourceType }
     * 
     */
    public LoadResourceType createLoadResourceType() {
        return new LoadResourceType();
    }

    /**
     * Create an instance of {@link ResourceType }
     * 
     */
    public ResourceType createResourceType() {
        return new ResourceType();
    }

    /**
     * Create an instance of {@link FullResourceType }
     * 
     */
    public FullResourceType createFullResourceType() {
        return new FullResourceType();
    }

    /**
     * Create an instance of {@link ResourceInfoType }
     * 
     */
    public ResourceInfoType createResourceInfoType() {
        return new ResourceInfoType();
    }

    /**
     * Create an instance of {@link EditedResourceInfoFullType }
     * 
     */
    public EditedResourceInfoFullType createEditedResourceInfoFullType() {
        return new EditedResourceInfoFullType();
    }

    /**
     * Create an instance of {@link ResourceInfoFullType }
     * 
     */
    public ResourceInfoFullType createResourceInfoFullType() {
        return new ResourceInfoFullType();
    }

    /**
     * Create an instance of {@link GetResourceInfoListRequest }
     * 
     */
    public GetResourceInfoListRequest createGetResourceInfoListRequest() {
        return new GetResourceInfoListRequest();
    }

    /**
     * Create an instance of {@link GetResourceInfoListByNameRequest }
     * 
     */
    public GetResourceInfoListByNameRequest createGetResourceInfoListByNameRequest() {
        return new GetResourceInfoListByNameRequest();
    }

    /**
     * Create an instance of {@link GetResourceInfoListByNamespaceRequest }
     * 
     */
    public GetResourceInfoListByNamespaceRequest createGetResourceInfoListByNamespaceRequest() {
        return new GetResourceInfoListByNamespaceRequest();
    }

    /**
     * Create an instance of {@link GetResourceInfoList }
     * 
     */
    public GetResourceInfoList createGetResourceInfoList() {
        return new GetResourceInfoList();
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link LoadResourceType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link LoadResourceType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/registry-schema-service/", name = "loadResourceRequest")
    public JAXBElement<LoadResourceType> createLoadResourceRequest(LoadResourceType value) {
        return new JAXBElement<LoadResourceType>(_LoadResourceRequest_QNAME, LoadResourceType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ResourceType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ResourceType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/registry-schema-service/", name = "ResourceType")
    public JAXBElement<ResourceType> createResourceType(ResourceType value) {
        return new JAXBElement<ResourceType>(_ResourceType_QNAME, ResourceType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link FullResourceType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link FullResourceType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/registry-schema-service/", name = "FullResourceType")
    public JAXBElement<FullResourceType> createFullResourceType(FullResourceType value) {
        return new JAXBElement<FullResourceType>(_FullResourceType_QNAME, FullResourceType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Long }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link Long }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/registry-schema-service/", name = "removeResourceRequest")
    public JAXBElement<Long> createRemoveResourceRequest(Long value) {
        return new JAXBElement<Long>(_RemoveResourceRequest_QNAME, Long.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Long }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link Long }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/registry-schema-service/", name = "getResourceRequest")
    public JAXBElement<Long> createGetResourceRequest(Long value) {
        return new JAXBElement<Long>(_GetResourceRequest_QNAME, Long.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ResourceInfoType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ResourceInfoType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/registry-schema-service/", name = "loadResourceInfoRequest")
    public JAXBElement<ResourceInfoType> createLoadResourceInfoRequest(ResourceInfoType value) {
        return new JAXBElement<ResourceInfoType>(_LoadResourceInfoRequest_QNAME, ResourceInfoType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link EditedResourceInfoFullType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link EditedResourceInfoFullType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/registry-schema-service/", name = "editResourceInfoRequest")
    public JAXBElement<EditedResourceInfoFullType> createEditResourceInfoRequest(EditedResourceInfoFullType value) {
        return new JAXBElement<EditedResourceInfoFullType>(_EditResourceInfoRequest_QNAME, EditedResourceInfoFullType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/registry-schema-service/", name = "removeResourceInfoRequest")
    public JAXBElement<String> createRemoveResourceInfoRequest(String value) {
        return new JAXBElement<String>(_RemoveResourceInfoRequest_QNAME, String.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/registry-schema-service/", name = "getResourceInfoRequest")
    public JAXBElement<String> createGetResourceInfoRequest(String value) {
        return new JAXBElement<String>(_GetResourceInfoRequest_QNAME, String.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ResourceInfoFullType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ResourceInfoFullType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/registry-schema-service/", name = "getResourceInfoResponse")
    public JAXBElement<ResourceInfoFullType> createGetResourceInfoResponse(ResourceInfoFullType value) {
        return new JAXBElement<ResourceInfoFullType>(_GetResourceInfoResponse_QNAME, ResourceInfoFullType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link GetResourceInfoList }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link GetResourceInfoList }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/registry-schema-service/", name = "getResourceInfoListResponse")
    public JAXBElement<GetResourceInfoList> createGetResourceInfoListResponse(GetResourceInfoList value) {
        return new JAXBElement<GetResourceInfoList>(_GetResourceInfoListResponse_QNAME, GetResourceInfoList.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/registry-schema-service/", name = "createdBy")
    public JAXBElement<String> createCreatedBy(String value) {
        return new JAXBElement<String>(_CreatedBy_QNAME, String.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/registry-schema-service/", name = "response")
    public JAXBElement<String> createResponse(String value) {
        return new JAXBElement<String>(_Response_QNAME, String.class, null, value);
    }

}
