/*-
 * ~~~~~~licensing~~~~~~
 * core-initializer
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.runtime.core.initializer.core;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import ru.entaxy.esb.platform.runtime.core.initializer.api.AbstractInitializer;
import ru.entaxy.esb.platform.runtime.core.initializer.api.InitializerException;

/**
 * 
 * NOOP-class for now, just to check everything works
 * Can be filled with the functionality in the future
 * 
 * @author sstarovoytenkov
 *
 */
public class CoreInitializer extends AbstractInitializer {

	protected static final Logger log = LoggerFactory.getLogger(CoreInitializer.class);
	
	@Override
	public void init() throws InitializerException {
		log.info("Init in CoreInitializer is called");
	}

	@Override
	public void reinit() throws InitializerException {
		log.info("ReInit in CoreInitializer is called");
	}

}
