/*-
 * ~~~~~~licensing~~~~~~
 * init-manager
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.runtime.core.initializer;

import org.apache.camel.tooling.model.Strings;
import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;
import org.osgi.framework.BundleEvent;
import org.osgi.util.tracker.BundleTracker;
import ru.entaxy.esb.platform.runtime.core.initializer.api.Initializer;

public class InitializerTracker extends BundleTracker<Object> {

	protected InitManager initManager;
	
	public InitializerTracker(BundleContext context, InitManager initManager) {
		super(context, Bundle.ACTIVE, null);
		this.initManager = initManager;
	}

	@Override
	public Object addingBundle(Bundle bundle, BundleEvent event) {
		String initializerClass = bundle.getHeaders().get(Initializer.INITIALIZER_CLASS_HEADER);
		if (!Strings.isNullOrEmpty(initializerClass)) {
			this.initManager.init(initializerClass, bundle);
		}
		return null;
	}
	
}
