/*-
 * ~~~~~~licensing~~~~~~
 * cluster-node-management
 * ==========
 * Copyright (C) 2020 - 2022 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.core.management.cluster.node.impl;

import com.hazelcast.core.Member;

import ru.entaxy.esb.platform.core.management.node.ClusterLocalNodeDataProvider;
import ru.entaxy.esb.platform.core.management.node.NodeDataProvider;

public class ClusterLocalNodeDataProviderImpl extends MemberAwareDataProvider implements ClusterLocalNodeDataProvider {

	protected NodeDataProvider localDataProvider;
	
	public ClusterLocalNodeDataProviderImpl(Member member, NodeDataProvider localDataProvider) {
		super(member);
		this.localDataProvider = localDataProvider;
	}
	
	@Override
	public String getEntaxyPlatformVersion() {
		return localDataProvider.getEntaxyPlatformVersion();
	}
	
	@Override
	public String getHttpPort() {
		return localDataProvider.getHttpPort();
	}
	
	@Override
	public String getSshPort() {
		return localDataProvider.getSshPort();
	}
	
	@Override
	public boolean isUIEnabled() {
		return localDataProvider.isUIEnabled();
	}
	
}
