/*-
 * ~~~~~~licensing~~~~~~
 * connection-management
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.core.management.connection;

public interface ConnectionMBean {
	
	public static final String CONNECTION_KEY = "connection";
	
	/*
	 * connection name
	 */
	public String getName();
	
	/*
	 * if connection is platform one or user defined
	 */
	public boolean isPlatform();
	
	/*
	 * status of the bundle if connection is deplyed
	 */
	public String getStatus();
	
	/*
	 * if the connection local or shared (cluster)
	 */
	public boolean isLocal();
	
	/*
	 * if the connection is shared (single malt)
	 * or prototype-like (blended)
	 */
	public boolean isShared();
	
	/*
	 * if the connection is deployed or only defined
	 */
	public boolean isDeployed();
	
	/*
	 * bundle id for single malt connection
	 * null for blended
	 */
	public String getBundleId();
	
}
