/*-
 * ~~~~~~licensing~~~~~~
 * profile-management
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.core.management.profile;

import ru.entaxy.esb.platform.base.management.core.Qualifier;
import ru.entaxy.esb.platform.base.management.core.utils.BundleAwareMBean;

public interface DefaultRouteMBean extends BundleAwareMBean {
	
	public static interface Helper {

		public static Qualifier getQualifier(String profileName) {
			return RoutesMBean.Helper.getQualifier(profileName).qualifier(ROUTE_KEY, ROUTE_KEY_VALUE_DEFAULT);
		}
		
	}
	

	public static final String CAPABILITY_NAMESPACE = "entaxy.runtime.default-route";
	
	public static final String ROUTE_KEY = "route";
	
	public static final String ROUTE_KEY_VALUE_DEFAULT = "default";
	
	public boolean isDefault();
	
}
