/*-
 * ~~~~~~licensing~~~~~~
 * profile-management
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.core.management.profile.impl.helper;

import org.osgi.service.component.annotations.Component;
import org.osgi.service.component.annotations.Reference;
import org.osgi.service.component.annotations.ReferenceCardinality;

import ru.entaxy.esb.platform.core.management.profile.impl.ProfileHelper;
import ru.entaxy.esb.platform.core.management.profile.impl.connector.ConnectorHelper;
import ru.entaxy.esb.platform.core.management.profile.impl.permission.PermissionHelper;
import ru.entaxy.esb.system.auth.basic.jpa.api.BasicAuthService;
import ru.entaxy.esb.system.jpa.SystemService;

@Component (service = Helpers.class, immediate = true)
public class Helpers {

	@Reference (cardinality = ReferenceCardinality.MANDATORY)
	public ProfileHelper profileHelper; 
	
	@Reference (cardinality = ReferenceCardinality.MANDATORY)
	public ConnectorHelper connectorHelper;
	
	@Reference (cardinality = ReferenceCardinality.MANDATORY)
	public BasicAuthService basicAuthService;
	
	@Reference (cardinality = ReferenceCardinality.MANDATORY)
	public SystemService systemService;
	
	@Reference (cardinality = ReferenceCardinality.MANDATORY)
	public PermissionHelper permissionHelper;
}
