# SYSTEM :: ENTAXY :: AUTH BASIC

Реализация web-сервиса для загрузки актуальных или измененных пользователей и их параметры аутентификации (логин АД или данные Basic авторизации)

##Admin

Стартовый пользователь **admin/admin**, записывается через liquibase, без связанной системы.

По умолчанию выданы права на управленческий слой, сервисы:
 - system-management
 - basic-auth-management
 - permission-management
 - topic-management
 
!!!Требуется сменить пароль!!!

Файл Htpasswd не генерируется до первого обращения к сервису basic-auth-management.

## Сборка

Сборка осуществляется командой

```
mvn clean install
```
По умолчанию запускается профиль dev, в котором прописаны параметры соединения к разработческой базе.

Запуск профиля для production: 

```
mvn clean install -Denv=prod
```

Параметры соединения хранятся в свойствах профилей в pom.xml

## Установка в karaf

Добавление репозитория в karaf

```
feature:repo-add mvn:ru.entaxy.esb/karaf-features/LATEST/xml/features
```

Установка auth basic

```
feature:install basic-auth
```

## Подключение cxf interceptor для идентификации систем

```
  <reference id="serviceInterceptor" interface="org.apache.cxf.phase.PhaseInterceptor"
               filter="(type=service)"/> 
	
	<cxf:bus id="esb-entaxy">
		<cxf:inInterceptors>
            <ref component-id="serviceInterceptor"/>
        </cxf:inInterceptors>
	</cxf:bus>
```

Интерцептор принимает заголовок с логином **X-ForwardedUser** от nginX

Данные по определённой системе записываются в заголовки

- **X-SystemName**
- **X-SystemUuid**  
- **X-SystemId**


