/*-
 * ~~~~~~licensing~~~~~~
 * basic-auth-api
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.auth.basic.jpa.api;

import ru.entaxy.esb.system.auth.basic.jpa.api.entity.BasicAuthAccount;
import ru.entaxy.esb.system.auth.basic.jpa.api.exception.BadPasswordException;

import java.security.NoSuchAlgorithmException;
import java.util.List;
import java.util.Optional;

public interface BasicAuthService {

    List<BasicAuthAccount> list();

    Optional<BasicAuthAccount> get(String login);
    
    Optional<BasicAuthAccount> getBySystem(String systemUuid);

    Optional<BasicAuthAccount> getByAuthorizationHeaderHash(String authorizationHeaderHash);

    BasicAuthAccount save(BasicAuthAccount basicAuthAccount, boolean isExist);

    public BasicAuthAccount saveFull(String login, String passwordHash, String encryptionAlgorithm, String systemUUID,
                                     String authorizationHeaderHash, String description, String createdBy, String editedBy);

    BasicAuthAccount saveCommon(String login, String passwordHash, String systemUUID, String createdBy, String editedBy)
            throws NoSuchAlgorithmException, BadPasswordException;

    BasicAuthAccount saveShort(String login, String passwordHash, String createdBy, String editedBy) throws NoSuchAlgorithmException, BadPasswordException;

    void remove(String login);

    boolean check(String login, String password);

}
