<!--
  ~~~~~~licensing~~~~~~
  error-handler
  ==========
  Copyright (C) 2020 - 2021 EmDev LLC
  ==========
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at
  
       http://www.apache.org/licenses/LICENSE-2.0
  
  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
  ~~~~~~/licensing~~~~~~
  -->
<xsl:stylesheet version="2.0"
                xmlns="http://www.entaxy.ru/ServiceInterface/1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
>

    <xsl:output omit-xml-declaration="yes" indent="yes"/>

    <xsl:param name="NTX_ERROR_HANDLER_CentralIntegrationDB"/>
    <xsl:param name="NTX_ERROR_HANDLER_Destination"/>
    <xsl:param name="NTX_ERROR_HANDLER_Source"/>
    <xsl:param name="NTX_ERROR_HANDLER_ErrorUUID"/>
    <xsl:param name="NTX_ERROR_HANDLER_Timestamp"/>
    <xsl:param name="NTX_ERROR_HANDLER_ResponseCode"/>
    <xsl:param name="NTX_ERROR_HANDLER_ResponseText"/>
    <xsl:param name="NTX_ERROR_HANDLER_SeverityLevel"/>
    <xsl:param name="NTX_ERROR_HANDLER_ExceptionClass"/>
    <xsl:param name="NTX_ERROR_HANDLER_Stacktrace"/>
    <xsl:param name="NTX_ERROR_HANDLER_EventName"/>
    <xsl:param name="ENTAXY_MessageUUID"/>
    <xsl:param name="ENTAXY_Source"/>
    <xsl:param name="ENTAXY_AcknowledgeMsgID"/>

    <xsl:template match="/">
        <Message>
            <Header xmlns="http://www.entaxy.ru/ServiceInterface/1.0">
                <Format>http://www.entaxy.ru/ServiceInterface/1.0</Format>
                <CreationDate>2020-05-20T07:19:59</CreationDate>
                <AvailableVersion>1</AvailableVersion>
            </Header>
            <Body xmlns="http://www.entaxy.ru/ServiceInterface/1.0">
                <Справочник.События>
                    <КлючевыеСвойства>
                        <Ссылка>
                            <xsl:value-of select="$NTX_ERROR_HANDLER_ErrorUUID"/>
                        </Ссылка>
                    </КлючевыеСвойства>
                    <Description>
                        <xsl:value-of select="$NTX_ERROR_HANDLER_ResponseText"/>
                    </Description>
                    <xsl:if test="$ENTAXY_MessageUUID">
                        <MessageUUID>
                            <xsl:value-of select="$ENTAXY_MessageUUID"/>
                        </MessageUUID>
                    </xsl:if>
                    <xsl:if test="$ENTAXY_AcknowledgeMsgID">
                        <TransportUUID>
                            <xsl:value-of select="$ENTAXY_AcknowledgeMsgID"/>
                        </TransportUUID>
                    </xsl:if>
                    <SeverityLevel>
                        <xsl:value-of select="$NTX_ERROR_HANDLER_SeverityLevel"/>
                    </SeverityLevel>
                    <EventName>Packet.Validation</EventName>
                    <Timestamp>
                        <xsl:value-of select="$NTX_ERROR_HANDLER_Timestamp"/>
                    </Timestamp>
                    <ErrorCode>
                        <xsl:value-of select="$NTX_ERROR_HANDLER_ResponseCode"/>
                    </ErrorCode>
                    <xsl:if test="$NTX_ERROR_HANDLER_ExceptionClass">
                        <ErrorClass>
                            <xsl:value-of select="$NTX_ERROR_HANDLER_ExceptionClass"/>
                        </ErrorClass>
                    </xsl:if>
                    <xsl:if test="$NTX_ERROR_HANDLER_Stacktrace">
                        <Context>
                            <xsl:value-of select="$NTX_ERROR_HANDLER_Stacktrace"/>
                        </Context>
                    </xsl:if>
                    <xsl:if test="$NTX_ERROR_HANDLER_Source">
                        <MessageSource>
                            <xsl:value-of select="$NTX_ERROR_HANDLER_Source"/>
                        </MessageSource>
                    </xsl:if>
                    <xsl:if test="$ENTAXY_Source">
                        <Source>
                            <xsl:value-of select="$ENTAXY_Source"/>
                        </Source>
                    </xsl:if>
                </Справочник.События>
            </Body>
        </Message>
    </xsl:template>
</xsl:stylesheet>
