/*-
 * ~~~~~~licensing~~~~~~
 * permission-component
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.core.permission.component.operation;

import org.apache.camel.Exchange;
import ru.entaxy.esb.system.core.permission.component.PermissionEndpoint;

public class GetByAllParams extends BaseOperation {

    @Override
    protected void doProcess(Exchange exchange, PermissionEndpoint endpoint) throws Exception {
        validateParams(String.valueOf(endpoint.getObjectId()), endpoint.getObjectType(),
                endpoint.getSubjectId(), endpoint.getSubjectType());
        exchange.getIn().setBody(getPermissionService().getByAllParameters(endpoint.getObjectId(), endpoint.getObjectType(),
                endpoint.getSubjectId(), endpoint.getSubjectType(), endpoint.getAction()));
    }

}
