/*-
 * ~~~~~~licensing~~~~~~
 * permission-handler
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.core.permission.handler;

import ru.entaxy.esb.system.core.permission.jpa.PermissionService;

public class PermissionCheckerImpl implements PermissionChecker {

    private PermissionService permissionService;

    public PermissionService getPermissionService() {
        return permissionService;
    }

    public void setPermissionService(PermissionService permissionService) {
        this.permissionService = permissionService;
    }

    public boolean check(int objectId, String objectType, String subjectId, String subjectType, String action) {
        return permissionService.existByAllParameters(objectId, objectType, subjectId, subjectType, action);
    }

    public boolean check(int objectId, String objectType, String subjectId, String subjectType) {
        return check(objectId, objectType, subjectId, subjectType, null);
    }
}
