/*-
 * ~~~~~~licensing~~~~~~
 * profile-commons
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.profile.commons.connectors.out;

import org.apache.camel.Exchange;
import org.apache.camel.ProducerTemplate;
import ru.entaxy.esb.system.profile.commons.connectors.CommonConnector;

public class DirectVMOutConnectorImpl extends CommonConnector implements OutConnector {

    @Override
    public String getEndpointType() {
        return endpointType;
    }

    @Override
    public void send(Exchange exchange) {
        ProducerTemplate template = exchange.getContext().createProducerTemplate();
        template.send("direct-vm:" + endpointName + "-" +
                endpointType + "-connector-" + systemName + "?block=true&timeout=60000", exchange);
    }
}
