/*-
 * ~~~~~~licensing~~~~~~
 * system-group-api
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.groups.registry.jpa;

import ru.entaxy.esb.system.groups.registry.jpa.entity.SystemGroupRegistry;

import java.util.Date;
import java.util.List;

/**
 * Simple interface systemGroupRegistry service.
 */
public interface SystemGroupRegistryService {

    List<SystemGroupRegistry> list();

    SystemGroupRegistry get(long id);

    SystemGroupRegistry getByUuid(String uuid);

    SystemGroupRegistry add(SystemGroupRegistry systemGroupRegistry);

    SystemGroupRegistry add(String uuid, String name, String description, Date createDate, Date editDate, String createdBy,
                            String editedBy, double version, String type, String connectorId, String descriptionFileUrl,
                            String endpointName, String address, String responseType);

    void remove(long id);

}
