/*-
 * ~~~~~~licensing~~~~~~
 * system-profile-collector
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.registry.systems.profile.collector;

import com.sun.istack.NotNull;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import ru.entaxy.esb.system.common.osgi.impl.CommonNamedReferenceListener;
import ru.entaxy.esb.system.registry.systems.profile.SystemCollectorListener;
import ru.entaxy.esb.system.registry.systems.profile.SystemProfile;

public class SystemProfileNamedListener extends CommonNamedReferenceListener<SystemProfile>
        implements SystemCollectorListener<SystemProfile> {
    protected static final Logger log = LoggerFactory.getLogger(SystemProfileNamedListener.class);

    @Override
    protected String getObjectName(@NotNull SystemProfile systemProfile) {
        return systemProfile.getSystemName();
    }

    private SystemProfile getSystemProfile(String id) {
        return registeredReferences.get(id);
    }
}
