/*-
 * ~~~~~~licensing~~~~~~
 * bridge-profile-manager
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.management.bridge.profile.manager;

import ru.entaxy.esb.system.management.bridge.profile.manager.dto.BridgeProfileDto;
import ru.entaxy.esb.system.management.bridge.profile.manager.sender.BridgeProfileType;
import ru.entaxy.esb.system.management.bundle.jpa.dto.BundleDto;

import java.util.List;

public interface BridgeProfileManager {

    BundleDto installBridgeProfile(BridgeProfileDto bridgeProfileDto) throws Exception;

    BundleDto startBridgeProfile(BridgeProfileDto bridgeProfileDto) throws Exception;

    BundleDto stopBridgeProfile(BridgeProfileDto bridgeProfileDto) throws Exception;

    BridgeProfileType getBridgeProfile(BridgeProfileDto bridgeProfileDto) throws Exception;

    List<BridgeProfileType> getBridgeProfiles() throws Exception;

    BundleDto uninstallBridgeProfile(BridgeProfileDto bridgeProfileDto) throws Exception;

    List<String> getListEsb() throws Exception;
}
