/*-
 * ~~~~~~licensing~~~~~~
 * bridge-profile-manager
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.management.bridge.profile.manager.mapper;

import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.Mappings;
import ru.entaxy.esb.system.jpa.entity.System;
import ru.entaxy.esb.system.management.bridge.profile.manager.sender.BridgeProfileType;
import ru.entaxy.esb.system.management.bundle.jpa.dto.BundleDto;
import ru.entaxy.esb.system.management.bundle.jpa.entity.BundleEntity;

import java.util.List;

@Mapper
public interface BridgeProfileMapper {

    @Mappings({
            @Mapping(source = "bundleName", target = "name"),
            @Mapping(source = "bundleUrl", target = "url"),
    })
    BundleEntity toBundleEntity(BundleDto bundle);
    
    @Mappings({
        @Mapping(target = "bundleName", source = "name"),
        @Mapping(target = "bundleUrl", source = "url"),
    })
    BundleDto toBundleDto(BundleEntity bundle);

    @Mappings({
            @Mapping(source = "name", target = "profileName"),
            @Mapping(source = "bundleEntity.status", target = "status"),
    })
    BridgeProfileType toBridgeProfileType(System system);

    @Mappings({
            @Mapping(source = "profileName", target = "name"),
            @Mapping(target = "createDate", expression = "java(new java.util.Date())"),
            @Mapping(source = "status", target = "bundleEntity.status"),
    })
    System toSystemEntity(BridgeProfileType bridgeProfileType);

    List<BridgeProfileType> toBridgeProfileTypes(List<System> systemList);
}
