/*-
 * ~~~~~~licensing~~~~~~
 * route-manager
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.management.route.manager;

import ru.entaxy.esb.system.management.bundle.manager.BundleManager;

public class RouteManagerImpl implements RouteManager {
    private static final String DEFAULT_ROUTE = "default-route";

    private BundleManager bundleManager;

    @Override
    public void createDefaultRoute(String systemName) throws Exception {
        bundleManager.installAndStartBundle(systemName, DEFAULT_ROUTE, String.valueOf(1.0));
    }

    @Override
    public void uninstallDefaultRoute(String systemName) throws Exception {
        bundleManager.uninstallBundle(systemName, DEFAULT_ROUTE, String.valueOf(1.0));
    }

    public void setBundleManager(BundleManager bundleManager) {
        this.bundleManager = bundleManager;
    }
}
