/*-
 * ~~~~~~licensing~~~~~~
 * system-management-api
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */

package ru.entaxy.esb.system.management.soap;

import javax.xml.bind.JAXBElement;
import javax.xml.bind.annotation.XmlElementDecl;
import javax.xml.bind.annotation.XmlRegistry;
import javax.xml.datatype.XMLGregorianCalendar;
import javax.xml.namespace.QName;


/**
 * This object contains factory methods for each 
 * Java content interface and Java element interface 
 * generated in the ru.entaxy.esb.system.management.soap package. 
 * <p>An ObjectFactory allows you to programatically 
 * construct new instances of the Java representation 
 * for XML content. The Java representation of XML 
 * content can consist of schema derived interfaces 
 * and classes representing the binding of schema 
 * type definitions, element declarations and model 
 * groups.  Factory methods for each of these are 
 * provided in this class.
 * 
 */
@XmlRegistry
public class ObjectFactory {

    private final static QName _GetProfileRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "getProfileRequest");
    private final static QName _CreateProfileRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "createProfileRequest");
    private final static QName _StopProfileRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "stopProfileRequest");
    private final static QName _StartProfileRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "startProfileRequest");
    private final static QName _RemoveProfileRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "removeProfileRequest");
    private final static QName _FullProfileType_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "fullProfileType");
    private final static QName _ListProfile_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "listProfile");
    private final static QName _ListFullProfile_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "listFullProfile");
    private final static QName _ListConnector_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "listConnector");
    private final static QName _CreateConnectorRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "createConnectorRequest");
    private final static QName _RemoveConnectorRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "removeConnectorRequest");
    private final static QName _StopConnectorRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "stopConnectorRequest");
    private final static QName _StartConnectorRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "startConnectorRequest");
    private final static QName _GetConnector_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "getConnector");
    private final static QName _ListEsb_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "listEsb");
    private final static QName _GetBridgeProfilesResponse_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "getBridgeProfilesResponse");
    private final static QName _CreateBridgeProfileRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "createBridgeProfileRequest");
    private final static QName _StopBridgeProfileRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "stopBridgeProfileRequest");
    private final static QName _StartBridgeProfileRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "startBridgeProfileRequest");
    private final static QName _RemoveBridgeProfileRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "removeBridgeProfileRequest");
    private final static QName _GetBridgeProfileRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "getBridgeProfileRequest");
    private final static QName _FullBridgeProfileType_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "fullBridgeProfileType");
    private final static QName _ListTemplate_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "listTemplate");
    private final static QName _Template_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "template");
    private final static QName _GetTemplateRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "getTemplateRequest");
    private final static QName _Response_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "response");
    private final static QName _CreatedBy_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "createdBy");
    private final static QName _CreatePermissionRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "createPermissionRequest");
    private final static QName _RemovePermissionRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "removePermissionRequest");
    private final static QName _GetPermissionsByObjectRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "getPermissionsByObjectRequest");
    private final static QName _GetPermissionsByObjectResponse_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "getPermissionsByObjectResponse");
    private final static QName _GetPermissionsBySubjectRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "getPermissionsBySubjectRequest");
    private final static QName _GetPermissionsBySubjectResponse_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "getPermissionsBySubjectResponse");
    private final static QName _CreatePermissionForObjectRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "createPermissionForObjectRequest");
    private final static QName _CreatePermissionForSubjectRequest_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "createPermissionForSubjectRequest");
    private final static QName _FullProfileTypeDescription_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "description");
    private final static QName _FullProfileTypeEditDate_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "editDate");
    private final static QName _FullProfileTypeEditedBy_QNAME = new QName("http://www.entaxy.ru/system-management-service/", "editedBy");

    /**
     * Create a new ObjectFactory that can be used to create new instances of schema derived classes for package: ru.entaxy.esb.system.management.soap
     * 
     */
    public ObjectFactory() {
    }

    /**
     * Create an instance of {@link ProfileType }
     * 
     */
    public ProfileType createProfileType() {
        return new ProfileType();
    }

    /**
     * Create an instance of {@link CreateProfileType }
     * 
     */
    public CreateProfileType createCreateProfileType() {
        return new CreateProfileType();
    }

    /**
     * Create an instance of {@link FullProfileType }
     * 
     */
    public FullProfileType createFullProfileType() {
        return new FullProfileType();
    }

    /**
     * Create an instance of {@link ListProfileRequest }
     * 
     */
    public ListProfileRequest createListProfileRequest() {
        return new ListProfileRequest();
    }

    /**
     * Create an instance of {@link ListProfileType }
     * 
     */
    public ListProfileType createListProfileType() {
        return new ListProfileType();
    }

    /**
     * Create an instance of {@link ListFullProfileType }
     * 
     */
    public ListFullProfileType createListFullProfileType() {
        return new ListFullProfileType();
    }

    /**
     * Create an instance of {@link ListConnectorRequest }
     * 
     */
    public ListConnectorRequest createListConnectorRequest() {
        return new ListConnectorRequest();
    }

    /**
     * Create an instance of {@link ListConnectorType }
     * 
     */
    public ListConnectorType createListConnectorType() {
        return new ListConnectorType();
    }

    /**
     * Create an instance of {@link CreateConnectorType }
     * 
     */
    public CreateConnectorType createCreateConnectorType() {
        return new CreateConnectorType();
    }

    /**
     * Create an instance of {@link GetConnectorType }
     * 
     */
    public GetConnectorType createGetConnectorType() {
        return new GetConnectorType();
    }

    /**
     * Create an instance of {@link ListEsbRequest }
     * 
     */
    public ListEsbRequest createListEsbRequest() {
        return new ListEsbRequest();
    }

    /**
     * Create an instance of {@link ListEsbType }
     * 
     */
    public ListEsbType createListEsbType() {
        return new ListEsbType();
    }

    /**
     * Create an instance of {@link GetBridgeProfilesRequest }
     * 
     */
    public GetBridgeProfilesRequest createGetBridgeProfilesRequest() {
        return new GetBridgeProfilesRequest();
    }

    /**
     * Create an instance of {@link ListBridgeProfileType }
     * 
     */
    public ListBridgeProfileType createListBridgeProfileType() {
        return new ListBridgeProfileType();
    }

    /**
     * Create an instance of {@link BridgeProfileType }
     * 
     */
    public BridgeProfileType createBridgeProfileType() {
        return new BridgeProfileType();
    }

    /**
     * Create an instance of {@link FullBridgeProfileType }
     * 
     */
    public FullBridgeProfileType createFullBridgeProfileType() {
        return new FullBridgeProfileType();
    }

    /**
     * Create an instance of {@link ListTemplateRequest }
     * 
     */
    public ListTemplateRequest createListTemplateRequest() {
        return new ListTemplateRequest();
    }

    /**
     * Create an instance of {@link ListTemplateType }
     * 
     */
    public ListTemplateType createListTemplateType() {
        return new ListTemplateType();
    }

    /**
     * Create an instance of {@link TemplateType }
     * 
     */
    public TemplateType createTemplateType() {
        return new TemplateType();
    }

    /**
     * Create an instance of {@link GetTemplate }
     * 
     */
    public GetTemplate createGetTemplate() {
        return new GetTemplate();
    }

    /**
     * Create an instance of {@link PermissionType }
     * 
     */
    public PermissionType createPermissionType() {
        return new PermissionType();
    }

    /**
     * Create an instance of {@link PermissionForObjectType }
     * 
     */
    public PermissionForObjectType createPermissionForObjectType() {
        return new PermissionForObjectType();
    }

    /**
     * Create an instance of {@link PermissionForSubjectType }
     * 
     */
    public PermissionForSubjectType createPermissionForSubjectType() {
        return new PermissionForSubjectType();
    }

    /**
     * Create an instance of {@link ExportAllowedType }
     * 
     */
    public ExportAllowedType createExportAllowedType() {
        return new ExportAllowedType();
    }

    /**
     * Create an instance of {@link ConnectorType }
     * 
     */
    public ConnectorType createConnectorType() {
        return new ConnectorType();
    }

    /**
     * Create an instance of {@link ParamListType }
     * 
     */
    public ParamListType createParamListType() {
        return new ParamListType();
    }

    /**
     * Create an instance of {@link ParamType }
     * 
     */
    public ParamType createParamType() {
        return new ParamType();
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "getProfileRequest")
    public JAXBElement<ProfileType> createGetProfileRequest(ProfileType value) {
        return new JAXBElement<ProfileType>(_GetProfileRequest_QNAME, ProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CreateProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link CreateProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "createProfileRequest")
    public JAXBElement<CreateProfileType> createCreateProfileRequest(CreateProfileType value) {
        return new JAXBElement<CreateProfileType>(_CreateProfileRequest_QNAME, CreateProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "stopProfileRequest")
    public JAXBElement<ProfileType> createStopProfileRequest(ProfileType value) {
        return new JAXBElement<ProfileType>(_StopProfileRequest_QNAME, ProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "startProfileRequest")
    public JAXBElement<ProfileType> createStartProfileRequest(ProfileType value) {
        return new JAXBElement<ProfileType>(_StartProfileRequest_QNAME, ProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "removeProfileRequest")
    public JAXBElement<ProfileType> createRemoveProfileRequest(ProfileType value) {
        return new JAXBElement<ProfileType>(_RemoveProfileRequest_QNAME, ProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link FullProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link FullProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "fullProfileType")
    public JAXBElement<FullProfileType> createFullProfileType(FullProfileType value) {
        return new JAXBElement<FullProfileType>(_FullProfileType_QNAME, FullProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ListProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ListProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "listProfile")
    public JAXBElement<ListProfileType> createListProfile(ListProfileType value) {
        return new JAXBElement<ListProfileType>(_ListProfile_QNAME, ListProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ListFullProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ListFullProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "listFullProfile")
    public JAXBElement<ListFullProfileType> createListFullProfile(ListFullProfileType value) {
        return new JAXBElement<ListFullProfileType>(_ListFullProfile_QNAME, ListFullProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ListConnectorType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ListConnectorType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "listConnector")
    public JAXBElement<ListConnectorType> createListConnector(ListConnectorType value) {
        return new JAXBElement<ListConnectorType>(_ListConnector_QNAME, ListConnectorType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CreateConnectorType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link CreateConnectorType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "createConnectorRequest")
    public JAXBElement<CreateConnectorType> createCreateConnectorRequest(CreateConnectorType value) {
        return new JAXBElement<CreateConnectorType>(_CreateConnectorRequest_QNAME, CreateConnectorType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link GetConnectorType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link GetConnectorType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "removeConnectorRequest")
    public JAXBElement<GetConnectorType> createRemoveConnectorRequest(GetConnectorType value) {
        return new JAXBElement<GetConnectorType>(_RemoveConnectorRequest_QNAME, GetConnectorType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link GetConnectorType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link GetConnectorType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "stopConnectorRequest")
    public JAXBElement<GetConnectorType> createStopConnectorRequest(GetConnectorType value) {
        return new JAXBElement<GetConnectorType>(_StopConnectorRequest_QNAME, GetConnectorType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link GetConnectorType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link GetConnectorType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "startConnectorRequest")
    public JAXBElement<GetConnectorType> createStartConnectorRequest(GetConnectorType value) {
        return new JAXBElement<GetConnectorType>(_StartConnectorRequest_QNAME, GetConnectorType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link GetConnectorType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link GetConnectorType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "getConnector")
    public JAXBElement<GetConnectorType> createGetConnector(GetConnectorType value) {
        return new JAXBElement<GetConnectorType>(_GetConnector_QNAME, GetConnectorType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ListEsbType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ListEsbType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "listEsb")
    public JAXBElement<ListEsbType> createListEsb(ListEsbType value) {
        return new JAXBElement<ListEsbType>(_ListEsb_QNAME, ListEsbType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ListBridgeProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ListBridgeProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "getBridgeProfilesResponse")
    public JAXBElement<ListBridgeProfileType> createGetBridgeProfilesResponse(ListBridgeProfileType value) {
        return new JAXBElement<ListBridgeProfileType>(_GetBridgeProfilesResponse_QNAME, ListBridgeProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BridgeProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link BridgeProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "createBridgeProfileRequest")
    public JAXBElement<BridgeProfileType> createCreateBridgeProfileRequest(BridgeProfileType value) {
        return new JAXBElement<BridgeProfileType>(_CreateBridgeProfileRequest_QNAME, BridgeProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BridgeProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link BridgeProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "stopBridgeProfileRequest")
    public JAXBElement<BridgeProfileType> createStopBridgeProfileRequest(BridgeProfileType value) {
        return new JAXBElement<BridgeProfileType>(_StopBridgeProfileRequest_QNAME, BridgeProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BridgeProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link BridgeProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "startBridgeProfileRequest")
    public JAXBElement<BridgeProfileType> createStartBridgeProfileRequest(BridgeProfileType value) {
        return new JAXBElement<BridgeProfileType>(_StartBridgeProfileRequest_QNAME, BridgeProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BridgeProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link BridgeProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "removeBridgeProfileRequest")
    public JAXBElement<BridgeProfileType> createRemoveBridgeProfileRequest(BridgeProfileType value) {
        return new JAXBElement<BridgeProfileType>(_RemoveBridgeProfileRequest_QNAME, BridgeProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BridgeProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link BridgeProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "getBridgeProfileRequest")
    public JAXBElement<BridgeProfileType> createGetBridgeProfileRequest(BridgeProfileType value) {
        return new JAXBElement<BridgeProfileType>(_GetBridgeProfileRequest_QNAME, BridgeProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link FullBridgeProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link FullBridgeProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "fullBridgeProfileType")
    public JAXBElement<FullBridgeProfileType> createFullBridgeProfileType(FullBridgeProfileType value) {
        return new JAXBElement<FullBridgeProfileType>(_FullBridgeProfileType_QNAME, FullBridgeProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ListTemplateType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ListTemplateType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "listTemplate")
    public JAXBElement<ListTemplateType> createListTemplate(ListTemplateType value) {
        return new JAXBElement<ListTemplateType>(_ListTemplate_QNAME, ListTemplateType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link TemplateType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link TemplateType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "template")
    public JAXBElement<TemplateType> createTemplate(TemplateType value) {
        return new JAXBElement<TemplateType>(_Template_QNAME, TemplateType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link GetTemplate }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link GetTemplate }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "getTemplateRequest")
    public JAXBElement<GetTemplate> createGetTemplateRequest(GetTemplate value) {
        return new JAXBElement<GetTemplate>(_GetTemplateRequest_QNAME, GetTemplate.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Boolean }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link Boolean }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "response")
    public JAXBElement<Boolean> createResponse(Boolean value) {
        return new JAXBElement<Boolean>(_Response_QNAME, Boolean.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "createdBy")
    public JAXBElement<String> createCreatedBy(String value) {
        return new JAXBElement<String>(_CreatedBy_QNAME, String.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link PermissionType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link PermissionType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "createPermissionRequest")
    public JAXBElement<PermissionType> createCreatePermissionRequest(PermissionType value) {
        return new JAXBElement<PermissionType>(_CreatePermissionRequest_QNAME, PermissionType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link PermissionType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link PermissionType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "removePermissionRequest")
    public JAXBElement<PermissionType> createRemovePermissionRequest(PermissionType value) {
        return new JAXBElement<PermissionType>(_RemovePermissionRequest_QNAME, PermissionType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "getPermissionsByObjectRequest")
    public JAXBElement<ProfileType> createGetPermissionsByObjectRequest(ProfileType value) {
        return new JAXBElement<ProfileType>(_GetPermissionsByObjectRequest_QNAME, ProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ListProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ListProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "getPermissionsByObjectResponse")
    public JAXBElement<ListProfileType> createGetPermissionsByObjectResponse(ListProfileType value) {
        return new JAXBElement<ListProfileType>(_GetPermissionsByObjectResponse_QNAME, ListProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "getPermissionsBySubjectRequest")
    public JAXBElement<ProfileType> createGetPermissionsBySubjectRequest(ProfileType value) {
        return new JAXBElement<ProfileType>(_GetPermissionsBySubjectRequest_QNAME, ProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ListProfileType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link ListProfileType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "getPermissionsBySubjectResponse")
    public JAXBElement<ListProfileType> createGetPermissionsBySubjectResponse(ListProfileType value) {
        return new JAXBElement<ListProfileType>(_GetPermissionsBySubjectResponse_QNAME, ListProfileType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link PermissionForObjectType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link PermissionForObjectType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "createPermissionForObjectRequest")
    public JAXBElement<PermissionForObjectType> createCreatePermissionForObjectRequest(PermissionForObjectType value) {
        return new JAXBElement<PermissionForObjectType>(_CreatePermissionForObjectRequest_QNAME, PermissionForObjectType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link PermissionForSubjectType }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link PermissionForSubjectType }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "createPermissionForSubjectRequest")
    public JAXBElement<PermissionForSubjectType> createCreatePermissionForSubjectRequest(PermissionForSubjectType value) {
        return new JAXBElement<PermissionForSubjectType>(_CreatePermissionForSubjectRequest_QNAME, PermissionForSubjectType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "description", scope = FullProfileType.class)
    public JAXBElement<String> createFullProfileTypeDescription(String value) {
        return new JAXBElement<String>(_FullProfileTypeDescription_QNAME, String.class, FullProfileType.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link XMLGregorianCalendar }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link XMLGregorianCalendar }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "editDate", scope = FullProfileType.class)
    public JAXBElement<XMLGregorianCalendar> createFullProfileTypeEditDate(XMLGregorianCalendar value) {
        return new JAXBElement<XMLGregorianCalendar>(_FullProfileTypeEditDate_QNAME, XMLGregorianCalendar.class, FullProfileType.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "editedBy", scope = FullProfileType.class)
    public JAXBElement<String> createFullProfileTypeEditedBy(String value) {
        return new JAXBElement<String>(_FullProfileTypeEditedBy_QNAME, String.class, FullProfileType.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     * 
     * @param value
     *     Java instance representing xml element's value.
     * @return
     *     the new instance of {@link JAXBElement }{@code <}{@link String }{@code >}
     */
    @XmlElementDecl(namespace = "http://www.entaxy.ru/system-management-service/", name = "description", scope = CreateProfileType.class)
    public JAXBElement<String> createCreateProfileTypeDescription(String value) {
        return new JAXBElement<String>(_FullProfileTypeDescription_QNAME, String.class, CreateProfileType.class, value);
    }

}
