/*-
 * ~~~~~~licensing~~~~~~
 * system-management-api
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.management.soap;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.xml.bind.annotation.XmlSeeAlso;

/**
 * This class was generated by Apache CXF 3.3.6
 * 2021-02-03T15:56:47.930+07:00
 * Generated source version: 3.3.6
 *
 */
@WebService(targetNamespace = "http://www.entaxy.ru/system-management-service/", name = "system-management-service")
@XmlSeeAlso({ObjectFactory.class})
@SOAPBinding(parameterStyle = SOAPBinding.ParameterStyle.BARE)
public interface SystemManagementService {

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/get-bridge-profile")
    @WebResult(name = "fullBridgeProfileType", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public FullBridgeProfileType getBridgeProfile(

        @WebParam(partName = "request", name = "getBridgeProfileRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        BridgeProfileType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/start-profile")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean startProfile(

        @WebParam(partName = "request", name = "startProfileRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        ProfileType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/remove-permission")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean removePermission(

        @WebParam(partName = "request", name = "removePermissionRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        PermissionType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/get-profile")
    @WebResult(name = "fullProfileType", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public FullProfileType getProfile(

        @WebParam(partName = "request", name = "getProfileRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        ProfileType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/stop-bridge-profile")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean stopBridgeProfile(

        @WebParam(partName = "request", name = "stopBridgeProfileRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        BridgeProfileType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/list-esb")
    @WebResult(name = "listEsb", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public ListEsbType getListEsb(

        @WebParam(partName = "request", name = "listEsbRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        ListEsbRequest request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/list-templates")
    @WebResult(name = "template", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public TemplateType getTemplate(

        @WebParam(partName = "request", name = "getTemplateRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        GetTemplate request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/remove-connector")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean removeConnector(

        @WebParam(partName = "request", name = "removeConnectorRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        GetConnectorType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/stop-profile")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean stopProfile(

        @WebParam(partName = "request", name = "stopProfileRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        ProfileType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/list-profiles")
    @WebResult(name = "listFullProfile", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public ListFullProfileType getProfiles(

        @WebParam(partName = "request", name = "listProfileRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        ListProfileRequest request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/stop-connector")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean stopConnector(

        @WebParam(partName = "request", name = "stopConnectorRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        GetConnectorType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/get-bridge-profiles")
    @WebResult(name = "getBridgeProfilesResponse", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public ListBridgeProfileType getBridgeProfiles(

        @WebParam(partName = "request", name = "getBridgeProfilesRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        GetBridgeProfilesRequest request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/list-connectors")
    @WebResult(name = "listConnector", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public ListConnectorType getConnectors(

        @WebParam(partName = "request", name = "listConnectorRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        ListConnectorRequest request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/get-permissions-by-object")
    @WebResult(name = "getPermissionsByObjectResponse", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public ListProfileType getPermissionsByObject(

        @WebParam(partName = "request", name = "getPermissionsByObjectRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        ProfileType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/create-profile")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean createProfile(

        @WebParam(partName = "request", name = "createProfileRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        CreateProfileType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/get-permissions-by-subject")
    @WebResult(name = "getPermissionsBySubjectResponse", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public ListProfileType getPermissionsBySubject(

        @WebParam(partName = "request", name = "getPermissionsBySubjectRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        ProfileType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/list-templates")
    @WebResult(name = "listTemplate", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public ListTemplateType getTemplates(

        @WebParam(partName = "request", name = "listTemplateRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        ListTemplateRequest request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/create-permission")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean createPermission(

        @WebParam(partName = "request", name = "createPermissionRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        PermissionType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/create-bridge-profile")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean createBridgeProfile(

        @WebParam(partName = "request", name = "createBridgeProfileRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        BridgeProfileType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/start-bridge-profile")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean startBridgeProfile(

        @WebParam(partName = "request", name = "startBridgeProfileRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        BridgeProfileType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/create-permission-for-subject")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean createPermissionForSubject(

        @WebParam(partName = "request", name = "createPermissionForSubjectRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        PermissionForSubjectType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/remove-bridge-profile")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean removeBridgeProfile(

        @WebParam(partName = "request", name = "removeBridgeProfileRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        BridgeProfileType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/remove-profile")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean removeProfile(

        @WebParam(partName = "request", name = "removeProfileRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        ProfileType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/create-permission-for-object")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean createPermissionForObject(

        @WebParam(partName = "request", name = "createPermissionForObjectRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        PermissionForObjectType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/create-connector")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean createConnector(

        @WebParam(partName = "request", name = "createConnectorRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        CreateConnectorType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );

    @WebMethod(action = "http://www.entaxy.ru/system-management-service/start-connector")
    @WebResult(name = "response", targetNamespace = "http://www.entaxy.ru/system-management-service/", partName = "response")
    public boolean startConnector(

        @WebParam(partName = "request", name = "startConnectorRequest", targetNamespace = "http://www.entaxy.ru/system-management-service/")
        GetConnectorType request,
        @WebParam(partName = "header", name = "createdBy", targetNamespace = "http://www.entaxy.ru/system-management-service/", header = true)
        java.lang.String header
    );
}
