/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.camel.model.transformer;

import org.apache.camel.spi.Metadata;

import javax.xml.bind.annotation.*;
import java.util.List;

/**
 * To configure transformers.
 */
@Metadata(label = "transformation", title = "Transformations")
@XmlRootElement(name = "transformers")
@XmlAccessorType(XmlAccessType.FIELD)
public class TransformersDefinition {

    @XmlElements({@XmlElement(required = false, name = "dataFormatTransformer", type = DataFormatTransformerDefinition.class),
                  @XmlElement(required = false, name = "endpointTransformer", type = EndpointTransformerDefinition.class),
                  @XmlElement(required = false, name = "customTransformer", type = CustomTransformerDefinition.class)})
    private List<TransformerDefinition> transformers;

    /**
     * The configured transformers
     */
    public void setTransformers(List<TransformerDefinition> transformers) {
        this.transformers = transformers;
    }

    public List<TransformerDefinition> getTransformers() {
        return transformers;
    }

}
